/* deamoninit.h -- a way to run a desired process as a deamon.. 

   Copyright (C) Kenneth 'Redhead' Nielsen <kn@redhead.dk>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */


/****
 * $Id: deamoninit.h,v 1.3 2003/07/22 22:03:42 redhead Exp $ 
 * $Log: deamoninit.h,v $
 * Revision 1.3  2003/07/22 22:03:42  redhead
 * Cleaned up the code, which included rewriting every structure in the program.
 * Fixed some error checking, to make sure theres no undocumentet parts that might
 * produce an error.
 *
 * Revision 1.2  2002/10/18 18:25:23  redhead
 * Added the use of boxes to create a surrounding box around the signature
 * This introduced the --with-boxes flag to configure.
 * If that flag isn't used it will default be assumed boxes isn't installed
 * Else the configure script will search for boxes, if none should be found
 * in the search path, you can use --with-boxes=/where to specify it.
 *
 ****/


#ifdef sigit
#ifndef __DEAMONINIT__
#define __DEAMONINIT__   1


#include "config.h" /* #include <every_fucking_thing> */


void deamon_init(const char* pname, int facility);


int init_fifo(FIFO* fifo);

int unlink_fifo(FIFO* fifo);

void ignore_sigpipe(int sig);

void caught_signal(int sig);

void install_sig_handler(unsigned short int verbose);

#endif
#endif
